unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, Buttons, Gauges, Geometr, ComCtrls, Spin;

type
  typkoule=record koule:tkoule; barva:tcolor end;
  tbox=record b1,b2:tbod; barva:tcolor end;
  ttriangl=record b1,b2,b3:tbod; barva:tcolor end;
  ttetragon=record b1,b2,b3,b4:tbod; barva:tcolor end;
  tobrazek=record b1,b2,b3,b4:tbod; cesta:string end;
  ppredmet=^tpredmet;
  ppole=^tpole;
  tpole=record
              radek:array [1..600] of tprimka;
              sloupec:array [1..800] of tprimka;
        end;
  tpredmet=record
                 typ:byte;
                 barva:tcolor;
                 obsah:array [1..12] of extended;
                 dalsi:ppredmet;
                 strink:string;
                 bitka:tbitmap;
                 pole:ppole;
           end;
  vracene=record
                t:extended;
                b:tbod;
                v:tvektor;
          end;
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    Uloit1: TMenuItem;
    Konec1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Bevel1: TBevel;
    Image1: TImage;
    Bevel2: TBevel;
    SaveDialog1: TSaveDialog;
    Nov1: TMenuItem;
    Nastaveni1: TMenuItem;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    Uloobr1: TMenuItem;
    Vektorovobr1: TMenuItem;
    Bitmapovobr1: TMenuItem;
    Bitmapa1: TMenuItem;
    Zobraz1: TMenuItem;
    Vypoti1: TMenuItem;
    Aplikuj2: TMenuItem;
    Info1: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    Uloit2: TMenuItem;
    ColorDialog1: TColorDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    procedure Otevt1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Nov1Click(Sender: TObject);
    procedure kresliline(b1,b2:tbod;c:tcolor);
    procedure Aplikuj1Click(Sender: TObject);
    procedure koule_kresli(a:typkoule);
    procedure Nastaveni1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Uloobr1Click(Sender: TObject);
    procedure Bitmapovobr1Click(Sender: TObject);
    procedure Zobraz1Click(Sender: TObject);
    procedure Vypoti1Click(Sender: TObject);
    procedure Aplikuj2Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Uloit2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form1: TForm1;
  hlava:ppredmet;
  pocet,krok:byte;
  stinitko:record plocha:tplocha; vzdalenost:extended; end;
  oko:record bod:tbod; vzdalenost,lupa:extended; end;
  kam:tbod;
  vangle,hangle,maxvz,minvz:extended;
  jmeno:string;
  min_barva:real;
implementation

uses Unit2, Unit3, Unit4, unit5;

{$R *.DFM}


function urcibod(a:tbod):tpoint;
var b:tprimka;
    moko,bd,oko2,mbod:tbod;
    rovx,rovy:tplocha;
    konbod:tpoint;
    i,t:extended;
begin
     b.bod:=a; b.vektor:=vektor(a.x-oko.bod.x,a.y-oko.bod.y,a.z-oko.bod.z);
     primka_plocha_prusecik(b,stinitko.plocha,bd,t);

     b.bod:=oko.bod; b.vektor:=vektor(kam.x-oko.bod.x,kam.y-oko.bod.y,kam.z-oko.bod.z);
     primka_plocha_prusecik(b,stinitko.plocha,moko,t);

     oko2.y:=kam.y+oko.vzdalenost*sin((vangle-1)*pi/180);
     oko2.x:=kam.x+oko.vzdalenost*cos((vangle-1)*pi/180)*sin(hangle*pi/180);
     oko2.z:=kam.z-oko.vzdalenost*cos((vangle-1)*pi/180)*cos(hangle*pi/180);
     b.bod:=oko2; b.vektor:=vektor(kam.x-oko2.x,kam.y-oko2.y,kam.z-oko2.z);
     primka_plocha_prusecik(b,stinitko.plocha,mbod,t);

     rovy.d:=0;
     rovy.vektor:=vektor(moko.x-mbod.x,moko.y-mbod.y,moko.z-mbod.z);
     rovy.d:=-dosad_bod_plocha(moko,rovy);

     rovx.d:=0;
     rovx.vektor:=vektor_souc(rovy.vektor,stinitko.plocha.vektor);
     rovx.d:=-dosad_bod_plocha(moko,rovx);
     bod_plocha_vzdalenost(bd,rovx,i); konbod.x:=round(i);
     bod_plocha_vzdalenost(bd,rovy,i); konbod.y:=round(i);
     urcibod.x:=round(199+oko.lupa*konbod.x);
     urcibod.y:=round(149-oko.lupa*konbod.y);
end;

function kouli_nacti(a:string):typkoule;
var i:integer;
    b:typkoule;
begin
     a:=copy(a,7,length(a)-6);

     i:=0; repeat inc(i) until a[i]=' ';
     b.koule.bod.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.koule.bod.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.koule.bod.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.koule.r:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     if a[1]='$' then b.barva:=stringtocolor(a) else b.barva:=stringtocolor('cl'+a);
     kouli_nacti:=b;
end;

function box_nacti(a:string):tbox;
var i:integer;
    b:tbox;
begin
     a:=copy(a,5,length(a)-4);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     if a[1]='$' then b.barva:=stringtocolor(a) else b.barva:=stringtocolor('cl'+a);
     box_nacti:=b;
end;


function cara_nacti(a:string):tbox;
var i:integer;
    b:tbox;
begin
     a:=copy(a,6,length(a)-5);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     if a[1]='$' then b.barva:=stringtocolor(a) else b.barva:=stringtocolor('cl'+a);
     cara_nacti:=b;
end;

function triangl_nacti(a:string):ttriangl;
var i:integer;
    b:ttriangl;
begin
     a:=copy(a,9,length(a)-8);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b3.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b3.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b3.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     if a[1]='$' then b.barva:=stringtocolor(a) else b.barva:=stringtocolor('cl'+a);
     triangl_nacti:=b;
end;

function tetragon_nacti(a:string):ttetragon;
var i:integer;
    b:ttetragon;
begin
     a:=copy(a,10,length(a)-9);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b3.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b3.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b3.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b4.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b4.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b4.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     if a[1]='$' then b.barva:=stringtocolor(a) else b.barva:=stringtocolor('cl'+a);
     tetragon_nacti:=b;
end;

function obrazek_nacti(a:string):tobrazek;
var i:integer;
    b:tobrazek;
begin
     a:=copy(a,9,length(a)-8);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b1.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b2.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b3.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b3.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b3.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     i:=0; repeat inc(i) until a[i]=' ';
     b.b4.x:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b4.y:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);
     i:=0; repeat inc(i) until a[i]=' ';
     b.b4.z:=strtofloat(copy(a,1,i-1));  a:=copy(a,i+1,length(a)-i);

     b.cesta:=a;
     obrazek_nacti:=b;
end;
procedure tform1.koule_kresli(a:typkoule);
var d:tbod;
    polomer,dc,dm,t:extended;
    p:tprimka;
    e:tpoint;

begin
     p.bod:=a.koule.bod; p.vektor:=vektor(a.koule.bod.x-oko.bod.x,a.koule.bod.y-oko.bod.y,a.koule.bod.z-oko.bod.z);
     primka_plocha_prusecik(p,stinitko.plocha,d,t);
     e:=urcibod(a.koule.bod);

     dc:=body_vzdalenost(a.koule.bod,oko.bod);
     dm:=body_vzdalenost(d,oko.bod);
     polomer:=oko.lupa*dm*a.koule.r/dc;

     image1.Canvas.pen.color:=a.barva;
     image1.Canvas.brush.Style:=bsclear;
     image1.Canvas.Ellipse(e.x-round(polomer),e.y-round(polomer),e.x+round(polomer),e.y+round(polomer));
end;

procedure tform1.kresliline(b1,b2:tbod;c:tcolor);
var a:tpoint;
begin
     image1.canvas.pen.color:=c;
     a:=urcibod(b1);
     image1.canvas.MoveTo(a.x,a.y);
     a:=urcibod(b2);
     image1.canvas.lineTo(a.x,a.y);
     image1.canvas.pixels[urcibod(b1).x,urcibod(b1).y]:=c;
end;

procedure tetragon_kresli(a:ttetragon);
begin
     form1.kresliline(a.b1,a.b2,a.barva);
     form1.kresliline(a.b2,a.b3,a.barva);
     form1.kresliline(a.b3,a.b4,a.barva);
     form1.kresliline(a.b4,a.b1,a.barva);
end;

procedure obrazek_kresli(a:tobrazek);
begin
     form1.kresliline(a.b1,a.b2,clwhite);
     form1.kresliline(a.b1,a.b3,clwhite);
     form1.kresliline(a.b1,a.b4,clwhite);
     form1.kresliline(a.b2,a.b3,clwhite);
     form1.kresliline(a.b2,a.b4,clwhite);
     form1.kresliline(a.b3,a.b4,clwhite);
end;

procedure box_kresli(a:tbox);
var tet:ttetragon;
begin
     tet.barva:=a.barva;
     tet.b1:=bod(a.b1.x,a.b1.y,a.b1.z);
     tet.b2:=bod(a.b2.x,a.b1.y,a.b1.z);
     tet.b3:=bod(a.b2.x,a.b2.y,a.b1.z);
     tet.b4:=bod(a.b1.x,a.b2.y,a.b1.z);
     tetragon_kresli(tet);
     tet.b1:=bod(a.b2.x,a.b1.y,a.b1.z);
     tet.b2:=bod(a.b2.x,a.b1.y,a.b2.z);
     tet.b3:=bod(a.b2.x,a.b2.y,a.b2.z);
     tet.b4:=bod(a.b2.x,a.b2.y,a.b1.z);
     tetragon_kresli(tet);
     tet.b1:=bod(a.b2.x,a.b1.y,a.b2.z);
     tet.b2:=bod(a.b2.x,a.b2.y,a.b2.z);
     tet.b3:=bod(a.b1.x,a.b2.y,a.b2.z);
     tet.b4:=bod(a.b1.x,a.b1.y,a.b2.z);
     tetragon_kresli(tet);
     tet.b1:=bod(a.b1.x,a.b1.y,a.b2.z);
     tet.b2:=bod(a.b1.x,a.b2.y,a.b2.z);
     tet.b3:=bod(a.b1.x,a.b2.y,a.b1.z);
     tet.b4:=bod(a.b1.x,a.b1.y,a.b1.z);
     tetragon_kresli(tet);
     tet.b1:=bod(a.b1.x,a.b1.y,a.b1.z);
     tet.b2:=bod(a.b2.x,a.b1.y,a.b1.z);
     tet.b3:=bod(a.b2.x,a.b1.y,a.b2.z);
     tet.b4:=bod(a.b1.x,a.b1.y,a.b2.z);
     tetragon_kresli(tet);
     tet.b1:=bod(a.b1.x,a.b2.y,a.b1.z);
     tet.b2:=bod(a.b2.x,a.b2.y,a.b1.z);
     tet.b3:=bod(a.b2.x,a.b2.y,a.b2.z);
     tet.b4:=bod(a.b1.x,a.b2.y,a.b2.z);
     tetragon_kresli(tet);
end;

procedure triangl_kresli(a:ttriangl);
begin
     form1.kresliline(a.b1,a.b2,a.barva);
     form1.kresliline(a.b2,a.b3,a.barva);
     form1.kresliline(a.b3,a.b1,a.barva);
end;

procedure TForm1.Otevt1Click(Sender: TObject);
var neco:string;
    res:word;
begin
     if memo1.Modified then begin
        neco:='Uloit projekt: '+extractfilename(jmeno)+'?';
        res:=MessageDlg(neco, mtConfirmation,[mbYes, mbNo,mbCancel], 0);
        if res=mrYes then begin
                        if jmeno='neznm projekt' then begin
                                      savedialog1.Filter:='3DWorld soubor (*.w3d)|*.w3d|Vechny soubory (*.*)|*.*';
                                      savedialog1.DefaultExt:='w3d';
                                      savedialog1.filename:='projekt.w3d';
                                      if savedialog1.execute then begin
                                         memo1.Lines.SaveToFile(savedialog1.filename);
                                         memo1.Modified:=false;
                                         jmeno:=savedialog1.filename;
                                         form1.caption:='3D World - '+extractfilename(jmeno);
                                 end end else memo1.Lines.SaveToFile(jmeno);
                       end;
        end;
     if opendialog1.Execute then begin
                                  memo1.Lines.LoadFromFile(opendialog1.filename);
                                  jmeno:=opendialog1.filename;
                                  form1.caption:='3D World - '+extractfilename(jmeno);
                                  memo1.Modified:=false;
                                 end;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
     close;
end;

procedure usporadej;
var mbod:tbod;
begin
     oko.bod.y:=kam.y+oko.vzdalenost*sin(vangle*pi/180);
     oko.bod.x:=kam.x+oko.vzdalenost*cos(vangle*pi/180)*sin(hangle*pi/180);
     oko.bod.z:=kam.z-oko.vzdalenost*cos(vangle*pi/180)*cos(hangle*pi/180);
     mbod.y:=stinitko.vzdalenost*sin(vangle*pi/180)+kam.y;
     mbod.x:=stinitko.vzdalenost*cos(vangle*pi/180)*sin(hangle*pi/180)+kam.x;
     mbod.z:=kam.z-stinitko.vzdalenost*cos(vangle*pi/180)*cos(hangle*pi/180);
     stinitko.plocha.vektor:=vektor(kam.x-oko.bod.x,kam.y-oko.bod.y,kam.z-oko.bod.z);
     stinitko.plocha.d:=0;
     stinitko.plocha.d:=-dosad_bod_plocha(mbod,stinitko.plocha);
end;

procedure TForm1.FormCreate(Sender: TObject);
var a:trect;
    i:integer;
begin
     maxvz:=0;
     minvz:=1000000;
     image1.Canvas.Brush.color:=clblack; a:=rect(0,0,399,299); image1.Canvas.FillRect(a);
     kam:=bod(0,0,0);  hangle:=0; vangle:=0; oko.vzdalenost:=500; oko.lupa:=1;
     stinitko.vzdalenost:=100;
     krok:=3;
     spinedit1.Value:=krok;
     usporadej;
     min_barva:=0.2;
     form1.caption:='3D World - neznm projekt';
     application.Title:='3D World';
     jmeno:='neznm projekt';
     if paramcount<>0 then begin
                                jmeno:='';
                                for i:=1 to paramcount do begin
                                                           jmeno:=jmeno+paramstr(i);
                                                           if i<>paramcount then jmeno:=jmeno+' ';
                                                          end;
                                memo1.Lines.LoadFromFile(jmeno);
                                form1.caption:='3D World - '+extractfilename(jmeno);
                           end;
end;

procedure TForm1.Uloit1Click(Sender: TObject);
begin
     savedialog1.Filter:='3DWorld soubor (*.w3d)|*.w3d|Vechny soubory (*.*)|*.*';
     savedialog1.DefaultExt:='w3d';
     savedialog1.filename:=jmeno;
     if savedialog1.execute then begin
                                  memo1.Lines.SaveToFile(savedialog1.filename);
                                  memo1.Modified:=false;
                                  jmeno:=savedialog1.filename;
                                  form1.caption:='3D World - '+extractfilename(jmeno);
                                 end;
end;

procedure TForm1.Nov1Click(Sender: TObject);
var neco:string;
    res:word;
begin
     if memo1.Modified then begin
        neco:='Uloit projekt: '+extractfilename(jmeno)+'?';
        res:=MessageDlg(neco, mtConfirmation,[mbYes, mbNo,mbCancel], 0);
        if res=mrYes then begin
                        if jmeno='neznm projekt' then begin
                                      savedialog1.Filter:='3DWorld soubor (*.w3d)|*.w3d|Vechny soubory (*.*)|*.*';
                                      savedialog1.DefaultExt:='w3d';
                                      savedialog1.filename:='projekt.w3d';
                                      if savedialog1.execute then begin
                                         memo1.Lines.SaveToFile(savedialog1.filename);
                                         memo1.Modified:=false;
                                         jmeno:=savedialog1.filename;
                                         form1.caption:='3D World - '+extractfilename(jmeno);
                                 end end else memo1.Lines.SaveToFile(jmeno);
                       end;
        end;
     memo1.Lines.Clear;
     memo1change(Sender);
     memo1.SetFocus;
     jmeno:='neznm projekt';
     form1.caption:='3D World - '+jmeno;
     memo1.Modified:=false;
end;

procedure vykresli;
var pom:ppredmet;
    i:integer;
    a:trect;
    pbox:tbox;
    ptriangl:ttriangl;
    pkoule:typkoule;
    ptetragon:ttetragon;
    pobrazek:tobrazek;
begin
     form1.image1.Canvas.Brush.color:=clblack; a:=rect(0,0,399,299); form1.image1.Canvas.FillRect(a);
     usporadej;
     pom:=hlava;
     for i:=1 to pocet do begin
                           case pom.typ of
                            1:begin
                                   pbox.b1:=bod(pom.obsah[1],pom.obsah[2],pom.obsah[3]);
                                   pbox.b2:=bod(pom.obsah[4],pom.obsah[5],pom.obsah[6]);
                                   pbox.barva:=pom.barva;
                                   box_kresli(pbox);
                            end;
                            2:begin
                                   pkoule.koule.bod:=bod(pom.obsah[1],pom.obsah[2],pom.obsah[3]);
                                   pkoule.koule.r:=pom.obsah[4]; pkoule.barva:=pom.barva;
                                   form1.koule_kresli(pkoule);
                            end;
                            3:begin
                                   form1.kresliline(bod(pom.obsah[1],pom.obsah[2],pom.obsah[3]),
                                               bod(pom.obsah[4],pom.obsah[5],pom.obsah[6]),pom.barva);
                            end;
                            4:begin
                                   ptriangl.b1:=bod(pom.obsah[1],pom.obsah[2],pom.obsah[3]);
                                   ptriangl.b2:=bod(pom.obsah[4],pom.obsah[5],pom.obsah[6]);
                                   ptriangl.b3:=bod(pom.obsah[7],pom.obsah[8],pom.obsah[9]);
                                   ptriangl.barva:=pom.barva;
                                   triangl_kresli(ptriangl);
                            end;
                            5:begin
                                   ptetragon.b1:=bod(pom.obsah[1],pom.obsah[2],pom.obsah[3]);
                                   ptetragon.b2:=bod(pom.obsah[4],pom.obsah[5],pom.obsah[6]);
                                   ptetragon.b3:=bod(pom.obsah[7],pom.obsah[8],pom.obsah[9]);
                                   ptetragon.b4:=bod(pom.obsah[10],pom.obsah[11],pom.obsah[12]);
                                   ptetragon.barva:=pom.barva;
                                   tetragon_kresli(ptetragon);
                              end;
                            6:begin
                                   pobrazek.b1:=bod(pom.obsah[1],pom.obsah[2],pom.obsah[3]);
                                   pobrazek.b2:=bod(pom.obsah[4],pom.obsah[5],pom.obsah[6]);
                                   pobrazek.b3:=bod(pom.obsah[7],pom.obsah[8],pom.obsah[9]);
                                   pobrazek.b4:=bod(pom.obsah[10],pom.obsah[11],pom.obsah[12]);
                                   pobrazek.cesta:=pom.strink;
                                   obrazek_kresli(pobrazek);
                              end;
                           end;
                           pom:=pom.dalsi;
                          end;
     form1.Image1.Repaint;
end;

procedure znic;
var i:integer;
    p1,p2:ppredmet;
begin
     if pocet=0 then exit;
     p1:=hlava;
     for i:=1 to pocet do begin
                           p2:=p1.dalsi;
                           dispose(p1);
                           p1:=p2;
                          end;
     hlava:=nil;
end;

procedure TForm1.Aplikuj1Click(Sender: TObject);
var i:integer;
    pom:ppredmet;
    ak:typkoule;
    ab,ac:tbox;
    atr:ttriangl;
    ate:ttetragon;
    ato:tobrazek;
begin
     znic;
     vypoti1.Enabled:=true;
     speedbutton1.Enabled:=false;
     bitbtn1.Enabled:=true;
     bitbtn2.Enabled:=true;
     bitbtn3.Enabled:=true;
     bitbtn4.Enabled:=true;
     bitbtn5.Enabled:=true;
     bitbtn6.Enabled:=true;
     bitbtn7.Enabled:=true;
     bitbtn8.Enabled:=true;
     button1.Enabled:=true;
     button2.Enabled:=true;
     hlava:=nil; pocet:=0;
     for i:=0 to memo1.Lines.Count-1 do begin
                                         inc(pocet);
                                         if pocet=1 then begin
                                                          new(hlava);
                                                          pom:=hlava;
                                                         end else begin
                                                          new(pom.dalsi);
                                                          pom:=pom.dalsi;
                                                         end;
                                         if copy(memo1.Lines.Strings[i],1,3)='box' then
                                                        begin
                                                         ab:=box_nacti(memo1.lines.strings[i]);
                                                         pom.typ:=1;
                                                         pom.barva:=ab.barva;
                                                         pom.obsah[1]:=ab.b1.x; pom.obsah[2]:=ab.b1.y; pom.obsah[3]:=ab.b1.z;
                                                         pom.obsah[4]:=ab.b2.x; pom.obsah[5]:=ab.b2.y; pom.obsah[6]:=ab.b2.z;
                                                         pom.dalsi:=nil;
                                                        end;
                                         if copy(memo1.Lines.Strings[i],1,5)='koule' then
                                                        begin
                                                         ak:=kouli_nacti(memo1.lines.strings[i]);
                                                         pom.typ:=2;
                                                         pom.barva:=ak.barva;
                                                         pom.obsah[1]:=ak.koule.bod.x; pom.obsah[2]:=ak.koule.bod.y; pom.obsah[3]:=ak.koule.bod.z; pom.obsah[4]:=ak.koule.r;
                                                         pom.dalsi:=nil;
                                                        end;
                                         if copy(memo1.Lines.Strings[i],1,4)='cara' then
                                                        begin
                                                         ac:=cara_nacti(memo1.lines.strings[i]);
                                                         pom.typ:=3;
                                                         pom.barva:=ac.barva;
                                                         pom.obsah[1]:=ac.b1.x; pom.obsah[2]:=ac.b1.y; pom.obsah[3]:=ac.b1.z;
                                                         pom.obsah[4]:=ac.b2.x; pom.obsah[5]:=ac.b2.y; pom.obsah[6]:=ac.b2.z;
                                                         pom.dalsi:=nil;
                                                        end;
                                         if copy(memo1.Lines.Strings[i],1,7)='triangl' then
                                                        begin
                                                         atr:=triangl_nacti(memo1.lines.strings[i]);
                                                         pom.typ:=4;
                                                         pom.barva:=atr.barva;
                                                         pom.obsah[1]:=atr.b1.x; pom.obsah[2]:=atr.b1.y; pom.obsah[3]:=atr.b1.z;
                                                         pom.obsah[4]:=atr.b2.x; pom.obsah[5]:=atr.b2.y; pom.obsah[6]:=atr.b2.z;
                                                         pom.obsah[7]:=atr.b3.x; pom.obsah[8]:=atr.b3.y; pom.obsah[9]:=atr.b3.z;
                                                         pom.dalsi:=nil;
                                                        end;
                                         if copy(memo1.Lines.Strings[i],1,8)='tetragon' then
                                                        begin
                                                         ate:=tetragon_nacti(memo1.lines.strings[i]);
                                                         pom.typ:=5;
                                                         pom.barva:=ate.barva;
                                                         pom.obsah[1]:=ate.b1.x; pom.obsah[2]:=ate.b1.y; pom.obsah[3]:=ate.b1.z;
                                                         pom.obsah[4]:=ate.b2.x; pom.obsah[5]:=ate.b2.y; pom.obsah[6]:=ate.b2.z;
                                                         pom.obsah[7]:=ate.b3.x; pom.obsah[8]:=ate.b3.y; pom.obsah[9]:=ate.b3.z;
                                                         pom.obsah[10]:=ate.b4.x; pom.obsah[11]:=ate.b4.y; pom.obsah[12]:=ate.b4.z;
                                                         pom.dalsi:=nil;
                                                        end;
                                         if copy(memo1.Lines.Strings[i],1,7)='obrazek' then
                                                        begin
                                                         ato:=obrazek_nacti(memo1.lines.strings[i]);
                                                         pom.typ:=6;
                                                         pom.obsah[1]:=ato.b1.x; pom.obsah[2]:=ato.b1.y; pom.obsah[3]:=ato.b1.z;
                                                         pom.obsah[4]:=ato.b2.x; pom.obsah[5]:=ato.b2.y; pom.obsah[6]:=ato.b2.z;
                                                         pom.obsah[7]:=ato.b3.x; pom.obsah[8]:=ato.b3.y; pom.obsah[9]:=ato.b3.z;
                                                         pom.obsah[10]:=ato.b4.x; pom.obsah[11]:=ato.b4.y; pom.obsah[12]:=ato.b4.z;
                                                         pom.strink:=ato.cesta;
                                                         pom.dalsi:=nil;
                                                        end;
         end;
         vykresli;
end;

procedure TForm1.Nastaveni1Click(Sender: TObject);
begin
     if form2.showmodal=mrOK then begin
                                   oko.vzdalenost:=strtofloat(form2.edit4.Text);
                                   vangle:=strtofloat(form2.edit5.Text);
                                   hangle:=strtofloat(form2.edit6.Text);
                                   kam.x:=strtofloat(form2.edit7.Text);
                                   kam.y:=strtofloat(form2.edit8.Text);
                                   kam.z:=strtofloat(form2.edit9.Text);
                                   stinitko.vzdalenost:=strtofloat(form2.edit10.Text);
                                   oko.lupa:=strtofloat(form2.edit1.Text);
                                   krok:=strtoint(form2.edit11.text);
                                   spinedit1.Value:=krok;
                                   vykresli;
                                  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
     oko.bod.y:=oko.bod.y+2*krok*cos(vangle*pi/180);
     oko.bod.z:=oko.bod.z+2*krok*sin(vangle*pi/180)*cos(hangle*pi/180);
     oko.bod.x:=oko.bod.x-2*krok*sin(vangle*pi/180)*sin(hangle*pi/180);
     kam.y:=kam.y+2*krok*cos(vangle*pi/180);
     kam.z:=kam.z+2*krok*sin(vangle*pi/180)*cos(hangle*pi/180);
     kam.x:=kam.x-2*krok*sin(vangle*pi/180)*sin(hangle*pi/180);
     vykresli;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
     oko.bod.y:=oko.bod.y-2*krok*cos(vangle*pi/180);
     oko.bod.z:=oko.bod.z-2*krok*sin(vangle*pi/180)*cos(hangle*pi/180);
     oko.bod.x:=oko.bod.x+2*krok*sin(vangle*pi/180)*sin(hangle*pi/180);
     kam.y:=kam.y-2*krok*cos(vangle*pi/180);
     kam.z:=kam.z-2*krok*sin(vangle*pi/180)*cos(hangle*pi/180);
     kam.x:=kam.x+2*krok*sin(vangle*pi/180)*sin(hangle*pi/180);
     vykresli;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
     oko.bod.x:=oko.bod.x-2*krok*cos(hangle*pi/180); kam.x:=kam.x-2*krok*cos(hangle*pi/180);
     oko.bod.z:=oko.bod.z-2*krok*sin(hangle*pi/180); kam.z:=kam.z-2*krok*sin(hangle*pi/180);
     vykresli;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
     oko.bod.x:=oko.bod.x+2*krok*cos(hangle*pi/180); kam.x:=kam.x+2*krok*cos(hangle*pi/180);
     oko.bod.z:=oko.bod.z+2*krok*sin(hangle*pi/180); kam.z:=kam.z+2*krok*sin(hangle*pi/180);
     vykresli;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
     vangle:=vangle+krok;
     if vangle>90 then vangle:=90;
     vykresli;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
     vangle:=vangle-krok;
     if vangle<-90 then vangle:=-90;
     vykresli;
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
     hangle:=hangle-krok;
     if hangle<0 then hangle:=hangle+360;
     vykresli;
end;

procedure TForm1.BitBtn8Click(Sender: TObject);
begin
     hangle:=hangle+krok;
     if hangle>360 then hangle:=hangle-360;
     vykresli;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
     bitbtn1.Enabled:=false;
     bitbtn2.Enabled:=false;
     bitbtn3.Enabled:=false;
     bitbtn4.Enabled:=false;
     bitbtn5.Enabled:=false;
     bitbtn6.Enabled:=false;
     bitbtn7.Enabled:=false;
     bitbtn8.Enabled:=false;
     button1.Enabled:=false;
     button2.Enabled:=false;
     speedbutton1.Enabled:=true;
     vypoti1.Enabled:=false;
end;

procedure TForm1.Uloobr1Click(Sender: TObject);
begin
     savedialog1.Filter:='Bitmapa (*.bmp)|*.bmp|Vechny soubory (*.*)|*.*';
     savedialog1.DefaultExt:='bmp';
     savedialog1.filename:='obrazek.bmp';
     if savedialog1.Execute then form4.image1.picture.SaveToFile(savedialog1.filename);
end;

procedure TForm1.Bitmapovobr1Click(Sender: TObject);
begin
     if form3.showmodal=mrOK then begin
                                   if form3.RadioButton1.checked then begin
                                                                       form4.image1.Width:=320;
                                                                       form4.image1.height:=200;
                                                                      end;
                                   if form3.RadioButton2.checked then begin
                                                                       form4.image1.Width:=640;
                                                                       form4.image1.height:=480;
                                                                      end;
                                   if form3.RadioButton3.checked then begin
                                                                       form4.image1.Width:=800;
                                                                       form4.image1.height:=600;
                                                                      end;
                                   if form3.RadioButton4.checked then begin
                                                                       form4.image1.Width:=1024;
                                                                       form4.image1.height:=768;
                                                                      end;
                                   if form3.RadioButton5.checked then begin
                                                                       form4.image1.Width:=strtoint(form3.edit1.text)-1;
                                                                       form4.image1.height:=strtoint(form3.edit2.text)-1;
                                                                      end;
                                   form4.ClientWidth:=form4.image1.Width;
                                   form4.ClientHeight:=form4.image1.Height;
                                  end;
end;

procedure TForm1.Zobraz1Click(Sender: TObject);
begin
     form4.Show;
end;

function protni_primku(a:tprimka):tcolor;

function protni_triangl(a1,a2,a3,b1,b2,b3,c1,c2,c3:extended;c:tcolor;var vr:vracene):tcolor;
var plo:tplocha;
    bo1,bo2,bo3:tbod;
    v1,v2,v3:tvektor;
    u1,u2,u3,uh:real;
begin
     plo.vektor:=vektor_souc(vektor(b1-a1,b2-a2,b3-a3),vektor(c1-a1,c2-a2,c3-a3));
     plo.d:=0;
     plo.d:=-dosad_bod_plocha(bod(a1,a2,a3),plo);
     if not primka_plocha_prusecik(a,plo,vr.b,vr.t) then begin
                                                    protni_triangl:=0;
                                                    exit;
                                                   end;
     vr.v:=plo.vektor;
     bo1:=bod(a1,a2,a3);
     bo2:=bod(b1,b2,b3);
     bo3:=bod(c1,c2,c3);
     v1:=body_vektor(vr.b,bo1);
     v2:=body_vektor(vr.b,bo2);
     v3:=body_vektor(vr.b,bo3);
     if not vektory_uhel(v1,v2,u1) then u1:=0;
     if not vektory_uhel(v2,v3,u2) then u2:=0;
     if not vektory_uhel(v3,v1,u3) then u3:=0;
     uh:=u1+u2+u3;
     if (vr.b.x=bo1.x) and (vr.b.y=bo1.y) and (vr.b.z=bo1.z) then protni_triangl:=c else
        if (vr.b.x=bo2.x) and (vr.b.y=bo2.y) and (vr.b.z=bo2.z) then protni_triangl:=c else
           if (vr.b.x=bo3.x) and (vr.b.y=bo3.y) and (vr.b.z=bo3.z) then protni_triangl:=c else
     if round(1000000*uh)=round(1000000*2*pi) then protni_triangl:=c else protni_triangl:=0;
end;

function protni_tetragon(a1,a2,a3,b1,b2,b3,c1,c2,c3,d1,d2,d3:extended;c:tcolor;var vr:vracene):tcolor;
var prvni,druhy:tcolor;
begin
     prvni:=protni_triangl(a1,a2,a3,b1,b2,b3,d1,d2,d3,c,vr);
     druhy:=protni_triangl(b1,b2,b3,c1,c2,c3,d1,d2,d3,c,vr);
     if prvni=0 then
                            protni_tetragon:=druhy
                      else
                            protni_tetragon:=c;
end;

function protni_obrazek(a1,a2,a3,a4:tbod; c:tbitmap; po:ppole; var vr:vracene):tcolor;
var prvni,druhy:tcolor;
    maxx,maxy:record index:integer; d:extended; end;
    i:integer;
    d1:extended;
begin
     prvni:=protni_triangl(a1.x,a1.y,a1.z,a2.x,a2.y,a2.z,a4.x,a4.y,a4.z,$ffffff,vr);
     druhy:=protni_triangl(a2.x,a2.y,a2.z,a3.x,a3.y,a3.z,a4.x,a4.y,a4.z,$ffffff,vr);
     if (prvni=0) and (druhy=0) then begin
                                      protni_obrazek:=0;
                                      exit;
                                     end;
     maxy.index:=1;
     bod_primka_vzdalenost(vr.b,po.radek[1],maxy.d);
     for i:=2 to c.height do begin
                            bod_primka_vzdalenost(vr.b,po.radek[i],d1);
                            if d1<maxy.d then begin maxy.d:=d1; maxy.index:=i end ELSE break;
                           end;
     maxx.index:=1;
     bod_primka_vzdalenost(vr.b,po.sloupec[1],maxx.d);
     for i:=2 to c.width do begin
                            bod_primka_vzdalenost(vr.b,po.sloupec[i],d1);
                            if d1<maxx.d then begin maxx.d:=d1; maxx.index:=i end ELSE break;
                           end;
     protni_obrazek:=c.Canvas.pixels[maxx.index-1,maxy.index-1];
end;

function protni_box(b1,b2:tbod; c:tcolor; var vr:vracene):tcolor;
procedure vyrovnej(var a1,a2:tbod);
var m:extended;
begin
     if a1.x>a2.x then begin m:=a1.x; a1.x:=a2.x; a2.x:=m; end;
     if a1.y>a2.y then begin m:=a1.y; a1.y:=a2.y; a2.y:=m; end;
     if a1.z>a2.z then begin m:=a1.z; a1.z:=a2.z; a2.z:=m; end;
end;
var plo:tplocha;
    t:array [1..6] of extended;
    b:array [1..6] of tbod;
    ma,i:integer;
begin
     vyrovnej(b1,b2);
     plo.vektor:=vektor(0,0,-1);
     plo.d:=0;
     plo.d:=-dosad_bod_plocha(b1,plo);
     if not primka_plocha_prusecik(a,plo,b[1],t[1]) then t[1]:=10e6;
     if not ((b[1].x<b2.x) and (b[1].x>b1.x) and (b[1].y<b2.y) and (b[1].y>b1.y)) then t[1]:=10e6;
     plo.d:=0;
     plo.d:=-dosad_bod_plocha(b2,plo);
     if not primka_plocha_prusecik(a,plo,b[2],t[2]) then t[2]:=10e6;
     if not ((b[2].x<b2.x) and (b[2].x>b1.x) and (b[2].y<b2.y) and (b[2].y>b1.y)) then t[2]:=10e6;
     plo.vektor:=vektor(1,0,0);
     plo.d:=0;
     plo.d:=-dosad_bod_plocha(b2,plo);
     if not primka_plocha_prusecik(a,plo,b[3],t[3]) then t[3]:=10e6;
     if not ((b[3].z<b2.z) and (b[3].z>b1.z) and (b[3].y<b2.y) and (b[3].y>b1.y)) then t[3]:=10e6;
     plo.d:=0;
     plo.d:=-dosad_bod_plocha(b1,plo);
     if not primka_plocha_prusecik(a,plo,b[4],t[4]) then t[4]:=10e6;
     if not ((b[4].z<b2.z) and (b[4].z>b1.z) and (b[4].y<b2.y) and (b[4].y>b1.y)) then t[4]:=10e6;
     plo.vektor:=vektor(0,1,0);
     plo.d:=0;
     plo.d:=-dosad_bod_plocha(b2,plo);
     if not primka_plocha_prusecik(a,plo,b[5],t[5]) then t[5]:=10e6;
     if not ((b[5].x<b2.x) and (b[5].x>b1.x) and (b[5].z<b2.z) and (b[5].z>b1.z)) then t[5]:=10e6;
     plo.d:=0;
     plo.d:=-dosad_bod_plocha(b1,plo);
     if not primka_plocha_prusecik(a,plo,b[6],t[6]) then t[6]:=10e6;
     if not ((b[6].x<b2.x) and (b[6].x>b1.x) and (b[6].z<b2.z) and (b[6].z>b1.z)) then t[6]:=10e6;
     ma:=1;
     for i:=2 to 6 do if t[i]<t[ma] then ma:=i;
     if t[ma]<>10e6 then begin
                          vr.t:=t[ma];
                          vr.b:=b[ma];
                          protni_box:=c;
                          case ma of
                           1:vr.v:=vektor(0,0,-1);
                           2:vr.v:=vektor(0,0,1);
                           3:vr.v:=vektor(1,0,0);
                           4:vr.v:=vektor(-1,0,0);
                           5:vr.v:=vektor(0,1,0);
                           6:vr.v:=vektor(0,-1,0);
                          end;
                         end else protni_box:=0;
end;

function protni_koule(a1,a2,a3,b1:extended;c:tcolor;var vr:vracene):tcolor;
var ko:tkoule;
    bd1,bd2:tbod;
    t1,t2:extended;
begin
     ko.bod:=bod(a1,a2,a3);
     ko.r:=b1;
     if Primka_Koule_Prusecik(a,ko,bd1,bd2,t1,t2) then begin
                                                  if t1<t2 then vr.b:=bd1 else vr.b:=bd2;
                                                  if t1<t2 then vr.t:=t1 else vr.t:=t2;
                                                  vr.v:=body_vektor(vr.b,bod(a1,a2,a3));
                                                  protni_koule:=c;
                                                 end else protni_koule:=0;
end;

var p:ppredmet;
    i:integer;
    a1,a2,a3,b1,b2,b3,c1,c2,c3,d1,d2,d3:extended;
    svetlo:tbod;
    uhel:real;
    bar:record r,rk,g,gk,b,bk:byte end;
    body:record
               pole:array [1..1200] of record
                                        barva:tcolor;
                                        vr:vracene;
                                       end;
               pocet:integer;
         end;
    max:record
          barva:tcolor;
          vr:vracene;
         end;
    vzd:extended;
    vzda:longint;
    plo:tplocha;
begin
     p:=hlava;
     body.pocet:=0;
     for i:=1 to pocet do begin
                           case p.typ of
     1:begin
            a1:=p.obsah[1]; a2:=p.obsah[2]; a3:=p.obsah[3]; b1:=p.obsah[4]; b2:=p.obsah[5]; b3:=p.obsah[6];
            inc(body.pocet); body.pole[body.pocet].barva:=protni_box(bod(a1,a2,a3),bod(b1,b2,b3),p.barva,body.pole[body.pocet].vr);
     end;
     2:begin
            a1:=p.obsah[1]; a2:=p.obsah[2]; a3:=p.obsah[3]; b1:=p.obsah[4];
            inc(body.pocet);
            body.pole[body.pocet].barva:=protni_koule(a1,a2,a3,b1,p.barva,body.pole[body.pocet].vr);
       end;
     4:begin
            a1:=p.obsah[1]; a2:=p.obsah[2]; a3:=p.obsah[3];
            b1:=p.obsah[4]; b2:=p.obsah[5]; b3:=p.obsah[6];
            c1:=p.obsah[7]; c2:=p.obsah[8]; c3:=p.obsah[9];
            inc(body.pocet); body.pole[body.pocet].barva:=protni_triangl(a1,a2,a3,b1,b2,b3,c1,c2,c3,p.barva,body.pole[body.pocet].vr);
     end;
     5:begin
            a1:=p.obsah[1]; a2:=p.obsah[2]; a3:=p.obsah[3];
            b1:=p.obsah[4]; b2:=p.obsah[5]; b3:=p.obsah[6];
            c1:=p.obsah[7]; c2:=p.obsah[8]; c3:=p.obsah[9];
            d1:=p.obsah[10]; d2:=p.obsah[11]; d3:=p.obsah[12];
            inc(body.pocet); body.pole[body.pocet].barva:=protni_tetragon(a1,a2,a3,b1,b2,b3,c1,c2,c3,d1,d2,d3,p.barva,body.pole[body.pocet].vr);
     end;
     6:begin
            a1:=p.obsah[1]; a2:=p.obsah[2]; a3:=p.obsah[3];
            b1:=p.obsah[4]; b2:=p.obsah[5]; b3:=p.obsah[6];
            c1:=p.obsah[7]; c2:=p.obsah[8]; c3:=p.obsah[9];
            d1:=p.obsah[10]; d2:=p.obsah[11]; d3:=p.obsah[12];
            inc(body.pocet); body.pole[body.pocet].barva:=protni_obrazek(bod(a1,a2,a3),bod(b1,b2,b3),bod(c1,c2,c3),bod(d1,d2,d3),p.bitka,p.pole,body.pole[body.pocet].vr);
     end;
                           end;
                           p:=p.dalsi;
                          end;
     max.barva:=clblack; max.vr.t:=1000000;
     for i:=1 to body.pocet do
         if (body.pole[i].barva<>clblack) and (body.pole[i].vr.t<max.vr.t)
         and (body.pole[i].vr.t>0) then begin
                                      max.barva:=body.pole[i].barva;
                                      max.vr.t:=body.pole[i].vr.t;
                                      max.vr.v:=body.pole[i].vr.v;
                                      max.vr.b:=body.pole[i].vr.b;
                                     end;
     if form3.radiobutton6.Checked then begin
                                      bod_plocha_vzdalenost(max.vr.b,stinitko.plocha,vzd);
                                      vzda:=255-round(51/80*vzd+255/4);
                                      if max.barva<>0 then begin
                                      if vzda<minvz then minvz:=vzda;
                                      if vzda>maxvz then maxvz:=vzda;
                                      end;
                                      if max.barva<>0 then protni_primku:=vzda*256*256+vzda*256+vzda
                                                           else protni_primku:=0;
                                     end else begin
                                         svetlo.x:=strtofloat(form3.Edit4.text);
                                         svetlo.y:=strtofloat(form3.Edit5.text);
                                         svetlo.z:=strtofloat(form3.Edit6.text);
                                         vektory_uhel(body_vektor(max.vr.b,svetlo),max.vr.v,uhel);
                                         bar.r:=colortorgb(max.barva) div (256*256);
                                         bar.g:=(colortorgb(max.barva) mod (256*256)) div 256;
                                         bar.b:=(colortorgb(max.barva) mod (256*256)) mod 256;
                                         plo.vektor:=max.vr.v;
                                         plo.d:=0;
                                         plo.d:=-dosad_bod_plocha(max.vr.b,plo);
                                         if dosad_bod_plocha(oko.bod,plo)*dosad_bod_plocha(svetlo,plo)<=0 then begin
                                                                                                                 bar.rk:=round(bar.r*min_barva);
                                                                                                                 bar.gk:=round(bar.g*min_barva);
                                                                                                                 bar.bk:=round(bar.b*min_barva);
                                                                                                                end else
                                            begin
                                                 bar.rk:=round(bar.r*abs(cos(uhel)));
                                                 bar.gk:=round(bar.g*abs(cos(uhel)));
                                                 bar.bk:=round(bar.b*abs(cos(uhel)));
                                                 if bar.rk<bar.r*min_barva then bar.rk:=round(bar.r*min_barva);
                                                 if bar.gk<bar.g*min_barva then bar.gk:=round(bar.g*min_barva);
                                                 if bar.bk<bar.b*min_barva then bar.bk:=round(bar.b*min_barva);
                                            end;
                                         protni_primku:=bar.bk+256*bar.gk+256*256*bar.rk;
                                     end;
end;

function zjisti_barvu(a,b:extended):tcolor;
var bodl,moko:tbod;
    c:tprimka;
    t:extended;
begin
     c.bod:=oko.bod;
     c.vektor:=vektor(kam.x-oko.bod.x,kam.y-oko.bod.y,kam.z-oko.bod.z);
     if primka_plocha_prusecik(c,stinitko.plocha,moko,t) then begin
        bodl.x:=moko.x+a*cos(hangle*pi/180);
        bodl.z:=moko.z+a*sin(hangle*pi/180);
        bodl.y:=moko.y;
        bodl.y:=bodl.y+b*cos(vangle*pi/180);
        bodl.z:=bodl.z+b*sin(vangle*pi/180)*cos(hangle*pi/180);
        bodl.x:=bodl.x-b*sin(vangle*pi/180)*sin(hangle*pi/180);
        c.bod:=oko.bod; c.vektor:=vektor(bodl.x-oko.bod.x,bodl.y-oko.bod.y,bodl.z-oko.bod.z);
        zjisti_barvu:=protni_primku(c);
     end else zjisti_barvu:=clblack;
end;

procedure TForm1.Vypoti1Click(Sender: TObject);
var a:trect;
    i,j,gau1,gau2:integer;
    pulka:record x,y:integer end;
    bitka:tbitmap;
    z1,z2:real;
    p:ppredmet;
               vv1,vv2,vh1,vh2:tvektor;
               a1,a2,a3,a4:tbod;
begin
     gau2:=-1;
     bitka:=tbitmap.Create;
     bitka.Width:=form4.image1.width;
     bitka.height:=form4.image1.Height;
     bitka.Canvas.Brush.color:=clgray;
     a:=rect(0,0,bitka.Width,bitka.Height);
     bitka.Canvas.FillRect(a);
     pulka.x:=(bitka.Width+1) div 2; pulka.y:=(bitka.height+1) div 2;
     p:=hlava;
     while p<>nil do begin
                      if p.typ=6 then begin
                                       p.bitka:=tbitmap.create;
                                       p.bitka.LoadFromFile(p.strink);
                                       new(p.pole);
                                       a1.x:=p.obsah[1]; a1.y:=p.obsah[2]; a1.z:=p.obsah[3];
                                       a2.x:=p.obsah[4]; a2.y:=p.obsah[5]; a2.z:=p.obsah[6];
                                       a3.x:=p.obsah[7]; a3.y:=p.obsah[8]; a3.z:=p.obsah[9];
                                       a4.x:=p.obsah[10]; a4.y:=p.obsah[11]; a4.z:=p.obsah[12];
                                       vv1:=vektor((a1.x-a4.x)/(p.bitka.height-1),(a1.y-a4.y)/(p.bitka.height-1),(a1.z-a4.z)/(p.bitka.height-1));
                                       vv2:=vektor((a2.x-a3.x)/(p.bitka.height-1),(a2.y-a3.y)/(p.bitka.height-1),(a2.z-a3.z)/(p.bitka.height-1));
                                       vh1:=vektor((a3.x-a4.x)/(p.bitka.width-1),(a3.y-a4.y)/(p.bitka.width-1),(a3.z-a4.z)/(p.bitka.width-1));
                                       vh2:=vektor((a2.x-a1.x)/(p.bitka.width-1),(a2.y-a1.y)/(p.bitka.width-1),(a2.z-a1.z)/(p.bitka.width-1));
                                       for i:=1 to p.bitka.Height do begin
                                           p.pole.radek[i].bod:=bod(a4.x+vv1.x*(i-1),a4.y+vv1.y*(i-1),a4.z+vv1.z*(i-1));
                                           p.pole.radek[i].vektor:=body_vektor(p.pole.radek[i].bod,bod(a3.x+vv2.x*(i-1),a3.y+vv2.y*(i-1),a3.z+vv2.z*(i-1)));
                                       end;
                                       for i:=1 to p.bitka.width do begin
                                           p.pole.sloupec[i].bod:=bod(a4.x+vh1.x*(i-1),a4.y+vh1.y*(i-1),a4.z+vh1.z*(i-1));
                                           p.pole.sloupec[i].vektor:=body_vektor(p.pole.sloupec[i].bod,bod(a1.x+vh2.x*(i-1),a1.y+vh2.y*(i-1),a1.z+vh2.z*(i-1)));
                                       end;
                                      end;
                      p:=p.dalsi;
                     end;
     application.Minimize;
     for j:=0 to bitka.Height do begin
                                  for i:=0 to bitka.Width do begin
                                      z1:=(i-pulka.x)*200/pulka.x; z2:=-(j-pulka.y)*200/pulka.x;
                                      bitka.Canvas.pixels[i,j]:=zjisti_barvu(z1/oko.lupa,z2/oko.lupa);
                                  end;
                                  gau1:=round(j*100/bitka.height);
                                  if gau1<>gau2 then begin
                                     gau2:=gau1;
                                     application.Title:='3D World - '+inttostr(gau1)+'%';
                                     end;
                                 end;
     application.Restore;
     p:=hlava;
     while p<>nil do begin
                      if p.typ=6 then begin
                                       p.bitka.Destroy;
                                       dispose(p.pole);
                                      end;
                      p:=p.dalsi;
                     end;
     application.Title:='3D World';
     form4.Image1.visible:=false;
     form4.Image1.picture.bitmap:=bitka;
     form4.Image1.visible:=true;
     bitka.Destroy;
     form4.position:=poScreenCenter;
     form4.show;
end;

procedure TForm1.Aplikuj2Click(Sender: TObject);
begin
     speedbutton1.Click;
end;

procedure TForm1.Info1Click(Sender: TObject);
begin
     aboutbox.showmodal;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
     oko.lupa:=oko.lupa+0.1;
     vykresli;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     oko.lupa:=oko.lupa-0.1;
     if oko.lupa<0.1 then oko.lupa:=0.1;
     vykresli;
end;

procedure TForm1.Uloit2Click(Sender: TObject);
begin
     if jmeno='neznm projekt' then begin
                                      savedialog1.Filter:='3DWorld soubor (*.w3d)|*.w3d|Vechny soubory (*.*)|*.*';
                                      savedialog1.DefaultExt:='w3d';
                                      savedialog1.filename:='projekt.w3d';
                                      if savedialog1.execute then begin
                                         memo1.Lines.SaveToFile(savedialog1.filename);
                                         memo1.Modified:=false;
                                         jmeno:=savedialog1.filename;
                                         form1.caption:='3D World - '+extractfilename(jmeno);
                                 end end else begin
                                               memo1.Lines.SaveToFile(jmeno);
                                               memo1.Modified:=false;
                                              end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var neco:string;
    res:word;
begin
     if not memo1.Modified then exit;
     neco:='Uloit projekt: '+extractfilename(jmeno)+'?';
     res:=MessageDlg(neco, mtConfirmation,[mbYes, mbNo,mbCancel], 0);
     if res=mrCancel then action:=caNone;
     if res=mrYes then begin
                        if jmeno='neznm projekt' then begin
                                      action:=caNone;
                                      savedialog1.Filter:='3DWorld soubor (*.w3d)|*.w3d|Vechny soubory (*.*)|*.*';
                                      savedialog1.DefaultExt:='w3d';
                                      savedialog1.filename:='projekt.w3d';
                                      if savedialog1.execute then begin
                                         memo1.Lines.SaveToFile(savedialog1.filename);
                                         memo1.Modified:=false;
                                         jmeno:=savedialog1.filename;
                                         form1.caption:='3D World - '+extractfilename(jmeno);
                                         action:=caFree;
                                 end end else memo1.Lines.SaveToFile(jmeno);
                       end;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
     krok:=spinedit1.Value;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
     if colordialog1.Execute then begin
                                   edit1.Text:=colortostring(colordialog1.color);
                                   edit1.SelectAll;
                                   edit1.CutToClipboard;
                                   memo1.PasteFromClipboard;
                                  end;
end;

end.
